using OpenCvSharp;
using Sdcb.PaddleOCR;
using Sdcb.PaddleOCR.KnownModels;

namespace ClipboardOCR
{
    public partial class MainFrm : Form
    {
        public MainFrm()
        {
            InitializeComponent();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            // а
            if (Clipboard.ContainsImage())
            {
                var img = Clipboard.GetImage();
                Clipboard.Clear();

                var fileName = DateTime.Now.ToString("yyyy_mm_dd_HH_mm_ss_fff") + ".png";
                if (!Directory.Exists("./imgs/"))
                {
                    Directory.CreateDirectory("./imgs/");
                }

                fileName = Path.Combine("./imgs/", fileName);
                img.Save(fileName);
                var mat = Cv2.ImRead(fileName);
                
                // ocr 
                var result = all.Run(mat);
                textBox1.AppendText(result.Text);
                textBox1.AppendText("\r\n");
            }
        }

        OCRModel model = KnownOCRModel.PPOcrServerV2;
        PaddleOcrAll all;

        private void Form1_Load(object sender, EventArgs e)
        {
            model.EnsureAll().Wait();
            all = new PaddleOcrAll(model.RootDirectory, model.KeyPath);


            if (Clipboard.ContainsImage())
            {
                Clipboard.Clear();
            }
        }
    }
}